package clmFlexCode;

import com.ibm.rational.test.lt.kernel.services.ITestExecutionServices;
import com.ibm.rational.test.lt.kernel.services.ITestLogManager;

/**
 * @author Skye Bischoff
 */
public class QMProjectIdExtraction implements
		com.ibm.rational.test.lt.kernel.custom.ICustomCode2 {

	/**
	 * Instances of this will be created using the no-arg constructor.
	 */
	public QMProjectIdExtraction() {
	}

	/**
	 * For javadoc of ICustomCode2 and ITestExecutionServices interfaces, select 'Help Contents' in the
	 * Help menu and select 'Extending Rational Performance Tester functionality' -> 'Extending test execution with custom code'
	 */
	public String exec(ITestExecutionServices tes, String[] args) {
		// Initialize variables
		String result = args[1];
		String delims = null;
		String[] singleProjectListing = null;
		ITestLogManager testLogManager = tes.getTestLogManager();
		
		// Try catch block to capture any null pointers to avoid RPT runtime exceptions when this code is given garbage variables
        try {
        	// Current targetProjectName to match
    		String targetProjectName = args[0];
        	
    		// Current QM Project ID, modify targetProjectName to match listing format
    		String currentQmProjectId = args[1];
    		targetProjectName = targetProjectName.replaceAll("%20", " ");
    		
    		// Project ID list which will come in one of two different formats
    		String projectIdList = args[2];
    		    		
    		if(projectIdList==null){
    			result = "PROJECTIDLIST_NULL";
    		}else if(projectIdList.contains("</dc:title>")){
    			// If the projectIdList contains xml project flag then parse this way
    			delims = "[/]+";
    			singleProjectListing = projectIdList.split(delims);
    			result = singleProjectListing[singleProjectListing.length-1];
    			result = result.substring(1,result.length());
    	    // New format for 6.0.3 RQM Login
    		}else if(projectIdList.indexOf("ProjectAreaDTO\",\"itemId\"")>0){
    			// If the projectiDList contains ProjectAreaDTO then parse the ID out as follows
    			delims = "[\"]+";
        		singleProjectListing = projectIdList.split(delims);
        		        		
        		for(int i = 0; i < singleProjectListing.length-6; i++){
        			if(singleProjectListing[i].equals("name")&&singleProjectListing[i+2].equals(targetProjectName)){
        				for(int h = i; h < singleProjectListing.length-6; i++){
        					if(singleProjectListing[i].equals("itemId")){
                		    	// Set projectId to next found ID, then we break in next if loop when we've found the correct project name 
                		    	result = singleProjectListing[i+2];
                		    	result = result.substring(1);
                		    	break;  // Once a result is found break out of the loop to avoid any accidental conclusions
                		    }// end if
        				}// end for loop        				
        		    }// end if 
        		}// end for loop 
            // Old format for 6.0 RQM Login
    		}else if(projectIdList.indexOf("ProjectAreaDTO")>0){
    			// If the projectiDList contains ProjectAreaDTO then parse the ID out as follows
    			delims = "[\"]+";
        		singleProjectListing = projectIdList.split(delims);
        		
        		for(int i = 0; i < singleProjectListing.length-6; i++){
        			if(singleProjectListing[i].equals("itemId")){
        		    	// Set projectId to next found ID, then we break in next if loop when we've found the correct project name 
        		    	result = singleProjectListing[i+2];
        		    	result = result.substring(1);
        		    }// end if
        			if(singleProjectListing[i].equals("name")&&singleProjectListing[i+2].equals(targetProjectName)){
        		    	break;  // Once a result is found break out of the loop to avoid any accidental conclusions
        		    }// end if 
        		}// end for loop 
    		}else{
    			result = "QM_PROJECTID_FAILED_TO_EXTRACT";
    		}// end if else
    	
    		   		
        }catch(Throwable t){
            // Log the exception and continue
        }// end try catch
        
        testLogManager.reportMessage("QMProjectId: "+result);
        return result;
	}

}
